export interface TransformOptions {
    /** Set the `property` of the package with given value. (eg: `version: "1.0.0"` sets the package version to `1.0.0`). */
    [key: string]: any;
    /** Removes specified properties from source package.json. */
    remove?: string[];
    /** Transform package.json in-place. */
    replace?: boolean;
    /** Keep folder structre starting from `basePath`. Sets to `""` to keep entire folder structure. */
    basePath?: string;
}
export declare function transform(src: string, dest: string, options?: TransformOptions): void;
