"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs"));
const isFileRegex = /\.(\w+){2,4}$/;
function isFile(src) {
    return isFileRegex.test(src);
}
exports.isFile = isFile;
function readFile(path) {
    return fs.readFileSync(path, { encoding: "utf8" });
}
exports.readFile = readFile;
function readJSON(path) {
    const content = readFile(path);
    return JSON.parse(content);
}
exports.readJSON = readJSON;
function writeFile(path, content) {
    fs.writeFileSync(path, content, { encoding: "utf8" });
}
exports.writeFile = writeFile;
function writeJSON(path, content) {
    writeFile(path, JSON.stringify(content, null, 2));
}
exports.writeJSON = writeJSON;
